/*
Copyright (C) 2011 Craciun Dan <craciun.dan@tuxarena.com>

This file is part of NeonView.

NeonView is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
(at your option) any later version.

NeonView is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with NeonView.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <unistd.h>
#include <dirent.h>

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#define NAME "NeonView"
#define VERSION "0.6.0"
#define AUTHOR "Craciun Dan"
#define EMAIL "craciun.dan@tuxarena.com"
#define HTTP "http://www.tuxarena.com/neonview"
#define CODENAME "Xiphophorus"
#define LICENSE "GPLv2"

typedef struct file_data {
	char fullpath[4097]; /* full path to the file */
	char path[4097]; /* path to the file, without the basename */
	char basename[257]; /* basename */
	char cwd[4097]; /* current working directory - the path from which the application was launched */
	char listd[4097]; /* directory to list */

	char disp[4097]; /* name of the relative or absolute path to display in gdk_pixbuf_new_from_file */

	char **files; /* array of strings holding all the images in a directory */

	long total; /* total number of images in a directory */
	long pos; /* index (current position) */

	int first; /* 1 if put_image_first is to be called */
} TFD;

typedef struct file_info {
	char format[5]; /* JPG, PNG, TIFF etc */

	int width;
	int height;
	int new_width;
	int new_height;
	int loaded;

	long size; /* size in bytes */
} TFI;

typedef struct config {
	char homedir[4097];
	char config_file[4097];

	int window_width; /* main window width, in pixels */
	int window_height; /* main window height, in pixels */
	int gtk_win_pos; /* main window position */

	char maximized[4097]; /* check11 - start maximized or not */
	char remember_win_size[4097]; /* check12 - remember main window size between sessions */
	char fit_next[4097]; /* check13 */
	char remember_fit[4097]; /* check14 */

	char window_title[257]; /* main window title to display in the titlebar */

	int active11, active12, active13, active14;
} TCFG;

typedef struct master {
	GtkWidget *window;

	GtkWidget *vbox;
	GtkWidget *menubar;
	GtkWidget *toolbar;

	GtkWidget *hbox1;
	GtkWidget *scrolled;

	GtkWidget *hbox2;
	GtkWidget *label1; /* filename */
	GtkWidget *label2; /* size in pixels */
	GtkWidget *label3; /* size in bytes */
	GtkWidget *label4; /* format */
	GtkWidget *label5; /* fit to window/normal size */

	GtkWidget *image;

	GdkPixbuf *pixbuf;

	GtkToolItem *next, *prev;
	GtkToolItem *normal_size, *fit_size;

	GtkWidget *menu_next, *menu_prev;

	/* settings */
	GtkWidget *win_set; /* settings window */
	GtkWidget *button_ok, *button_no; /* OK and Cancel buttons in the Settings window */
	GtkWidget *label_help;

	GtkWidget *check11, *check12, *check13, *check14;

	TFD *tfd; /* file data */
	TFI *tfi; /* file info */
	TCFG *tcfg; /* config */

	int fit_images;
} TM;

#include "main.h"
#include "utils.h"
#include "config.h"
#include "help.h"
#include "widgets.h"
#include "image.h"
#include "save.h"
#include "settings.h"
#include "zoom.h"
//#include "info.h"
